#========================================
# _azurectl
#----------------------------------------
function _azurectl {
    local cur prev opts
    _get_comp_words_by_ref cur prev
    local cmd=$(echo $COMP_LINE | sed -e 's@-.*@@'| awk -F ' ' '{ print $NF }')
    for comp in $prev $cmd;do
        case "$comp" in
            "--debug")
                __comp_reply "setup compute"
                return 0
                ;;
            "setup")
                __comp_reply "account"
                return 0
                ;;
            "compute")
                __comp_reply "storage image request vm"
                return 0
                ;;
            "account")
                __comp_reply "configure default region list remove add --help help"
                return 0
                ;;
            "request")
                __comp_reply "status help --help wait"
                return 0
                ;;
            "image")
                __comp_reply "help unreplicate create list publish replicate --help delete"
                return 0
                ;;
            "storage")
                __comp_reply "account container help share upload --help delete"
                return 0
                ;;
            "vm")
                __comp_reply "create help --help types delete"
                return 0
                ;;
            "status")
                __comp_reply "--id"
                return 0
                ;;
            "account")
                __comp_reply "list help"
                return 0
                ;;
            "container")
                __comp_reply "sas list help show"
                return 0
                ;;
            "configure")
                __comp_reply "help --region --container-name --publish-settings-file --storage-account-name --name"
                return 0
                ;;
            "default")
                __comp_reply "--name"
                return 0
                ;;
            "unreplicate")
                __comp_reply "--name"
                return 0
                ;;
            "create")
                __comp_reply "--name --label --blob --password --ssh-private-key-file --cloud-service-name --fingerprint --user --instance-name --instance-type --image-name --custom-data --ssh-port"
                return 0
                ;;
            "share")
                __comp_reply "create list delete"
                return 0
                ;;
            "upload")
                __comp_reply "--source --quiet --max-chunk-size --name"
                return 0
                ;;
            "publish")
                __comp_reply "--name --msdn --private"
                return 0
                ;;
            "add")
                __comp_reply "--name --subscription-id --publish-settings-file"
                return 0
                ;;
            "replicate")
                __comp_reply "--regions --name --sku --image-version --offer"
                return 0
                ;;
            "remove")
                __comp_reply "--name"
                return 0
                ;;
            "wait")
                __comp_reply "--id"
                return 0
                ;;
            "region")
                __comp_reply "default add help"
                return 0
                ;;
            "delete")
                __comp_reply "--name --delete-disk --cloud-service-name --instance-name"
                return 0
                ;;
            "sas")
                __comp_reply "--start-datetime --expiry-datetime --permissions"
                return 0
                ;;
            "default")
                __comp_reply "--name"
                return 0
                ;;
            "create")
                __comp_reply "--name"
                return 0
                ;;
            "add")
                __comp_reply "--name --container-name --storage-account-name"
                return 0
                ;;
            "delete")
                __comp_reply "--name"
                return 0
                ;;
        esac
    done
    if [[ $COMP_LINE =~ compute ]];then
        __comp_reply "--help"
    else
       __comp_reply "--output-format compute help --region --storage-container setup --output-style --config --account --debug --version --help --storage-account"
    fi
    return 0
}
#========================================
# comp_reply
#----------------------------------------
function __comp_reply {
    word_list=$@
    COMPREPLY=($(compgen -W "$word_list" -- ${cur}))
}

complete -F _azurectl -o default azurectl
